//  Beispiel 18.1: HTTP Daten von einem ALL3500 holen und anzeigen
//
//  Unter Verwendung der IoT32 Brick Library

#include <all_IoT32.h>

// Beispiel für den ersten Sensor, der übergeben wird:
//
// L...!....1....!....2....!....3....!....4....!....5....!....6....!....7....!....8....!....9....!....0
// [{"id":"1","name":"Interner Sensor","description":"Temperatursensor","fe_view":"1","sort":"2:2",
// "fe_cvs_show_typ":"1","actor_analogValue":null,"digitalToText":"0::","tileColors":"1e7eac:900000:900000",
// "tileFormats":"55:","lang_port_identifier":null,"fading":null,"device_type":"4","value":"36.00","error":0,
// "config":{"icon":"","display":{"min":"0","max":"60"},"limit":{"min":"5","max":"50"}},"info":{"activ":"1",
// "enabled":"1","unit":"\u00b0C","type":"1","view":"1","chipid":"2","chipnumber":"2","chipaddress":"3",
// "helperchipnumber":"0","helperchipaddress":"0","bitaddress":"0"},"minmax":{"today":{"min":"35.50","max":"37.12"},
// "absolute":{"min":"19.62","max":"255.93"}},"connection":{"port":"4","bus":"67","group":"0"}},


void setup()
{
  IoT_Init(true);
  IoT_TerminalWaitInit(true);
  IoT_WLANautoConnect(true);                                        // Verbindung, ggf. gespeicherte, über WLAN herstellen
}

void loop()
{
  String page = "http://allnetuser:allnetpassword@192.168.1.64/xml/json.php?mode=all";    // Webseite des ALL3500 hier eintragen incl. Zugangsdaten
  HTTPClient http;
  http.begin(page); //HTTP
  int httpCode = http.GET();  // start connection and send HTTP header
  Serial.print("HTTP GET Result: " + str(httpCode) + ", Length = ");
  if (httpCode > 0)  // httpCode will be negative on error
  {   // HTTP header has been send and Server response header has been handled
    if (httpCode > 0)
    {
      String result = http.getString();
      int L = len(result);
      int p = 1;
      int n = 1;
      Serial.println(str(L));
      Serial.println("");
      Serial.println(fillcenter(" " + page + " ", "-", 80) + chr(8));
      int count = 0;
      while ((p > 0) && (n > 0))
      {
        p = position(result, quotate("name"), p);
        if (p > 0)
        {
          n = position(result, chr(34), p + 8);
          if (n > 0)
          {
            int L = n - p - 8;
            String SensorName = convertescape(mid(result, p + 8, L));
            p = position(result, quotate("description"), n);
            if (p > 0)
            {
              n = position(result, chr(34), p + 15);
              if (n > 0)
              {
                int L = n - p - 15;
                String SensorDescr = convertescape(mid(result, p + 15, L));
                p = position(result, quotate("value"), n);
                if (p > 0)
                {
                  n = position(result, chr(34), p + 9);
                  if (n > 0)
                  {
                    int L = n - p - 9;
                    String SensorValue = convertescape(mid(result, p + 9, L));
                    p = position(result, quotate("unit"), n);
                    if (p > 0)
                    {
                      n = position(result, chr(34), p + 8);
                      if (n > 0)
                      {
                        int L = n - p - 8;
                        String SensorUnit = convertescape(mid(result, p + 8, L));
                        Serial.print(strform(count + 1, 48, 2, false) + " : ");
                        Serial.print(left(SensorName + spc(25), 25));
                        Serial.print(" = ");
                        Serial.print(left(SensorDescr + spc(25), 25));
                        Serial.print(" = ");
                        Serial.print(left(SensorValue, 20));
                        Serial.print(SensorUnit);
                        Serial.println("");
                        count += 1;
                        p = position(result, "," + quotate("group") + ":", p);
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
      Serial.println(repeatstr("-", 80) + chr(8));
    }
  }
  else
  {
    Serial.println("0, Error Message: " + http.errorToString(httpCode));
  }
  http.end();
  IoT_ShutDown();
}
